function JCnrange_suportlines(A,J,C,m)
global definite
clc;
%disp('');disp('');disp('');disp('');
%disp('Programmer: Bebiano et al.');
%disp(' Department of Mathematics');
%disp(' Coimbra University');
%disp(' Coimbra, PORTUGAL');
%disp(' e-mail: bebiano@mat.uc.pt');
%disp(' ');
%disp(' December 2008')
%disp(' This file is named as JCnrange_suportlines.m');
%disp('1. run matlab');
%disp('2. input this file JCnrange_suportlines.m and all the routines necessaries that');
%disp('2. can be found on http://www.mat-uc.pt/~bebiano');
%disp(' ')
%disp(' This program produces the supporting lines of the J-tracial numerical range of a ');
%disp('complex matrix by using MATLAB package, where J is a Hermitian 
%disp('involutive matrix that defines the indefinite inner product');
%disp('of the same size of A');
%disp('You need to enter a complex matrix A, a Hermitian involutive complex '); 
%disp('matrix J of the same size of A, a real diagonal matrix and a positive integer number m');
%disp('eg. A=[2+3*i 2; 0 -2+3*i] enter, J=[1 0; 0 -1] enter, C=[2 0; 0 -1] enter and m=30 enter ');
%disp(' ');
%disp(' ****** Press any key to run the program ******');
%pause;

%%

Tol=10^(-5); 
i=sqrt(-1);

%A=input('enter a matrix A= ');
%J=input('enter a an Hermitian involutive matrix J= ');
%C=input('enter a diagonal matrix C= ');
%m=input('enter steps m= ');

% The begin of program


m=20;


m=round(m);
if m<10  
    m=10; 
end 

%%
%Checking the existence of some kind of errors
if ~isequal(size(J,1),size(J,2)) 
    error('J must be a square matrix');
end

if ~isequal(size(A,1),size(A,2))
    error('A must be a square matrix');
end

if ~isequal(size(C,1),size(C,2))
    error('C must be a square matrix');
end

for r=1:size(C,2)
    for s=1:size(C,2)
        if r~=s && C(r,s)~=0
            error('C must be a diagonal matrix');
        end
    end
end

for r=1:size(C,2)
    if imag(C(r,r))~=0
       error('C must be a real matrix');
    end
end


if ~isequal(size(J),size(A)) && ~isequal(size(C),size(A))
    error('A, J and C must have the same size');
end

for r=1:size(J,2)
    for s=1:size(J,2)
        if r~=s && J(r,s)~=0 || J(r,r)~=1 && J(r,r)~=-1
            error('J must be an Hermitian involutive matrix');
        end
    end
end

%%
%Degenerate case (A is scalar)
    if isequal(A, A(1,1)*eye(size(J,2)))==1
        c=0;
        for j=1:size(C,2)
           c=c+C(j,j);
        end
        plot(real(A(1,1)*c),imag(A(1,1)*c),'.blue', 'MarkerSize',5)         
        title('Since the matrix A is scalar, W_C^J(A) is a singleton')
        return;
    end

%%
%Degenerate case (C is scalar)
    if isequal(C, C(1,1)*eye(size(J,2)))==1
        a=0;
        for j=1:size(A,2)
           a=a+A(j,j);
        end
        plot(real(C(1,1)*a),imag(C(1,1)*a),'.blue', 'MarkerSize',5)         
        title('Since the matrix C is scalar, W_C^J(A) is a singleton')
        return;
    end
%%
%Degenerate case (A is J-scalar)
if ~isequal(J,eye(size(J,2))) && ~isequal(J,-eye(size(J,2))) %indefinite case
    c=0;
    if C(1,1)==1
        for j=2:size(C,2)
            if C(j,j)~=0
                c=1;
                break
            end
        end
    else
        c=1;
    end
    B=J*A; 
        if isequal(B,B(1,1)*eye(size(J,2)))==1 %A is J-scalar
            if c==0 %if C=diag(1,0,...,0)
                t1=1:0.005:10;
                h1=B(1,1)*t1;
                plot(real(h1),imag(h1),'b')
                hold on
                t2=-1:-0.005:-10;
                h2=B(1,1)*t2;
                plot(real(h2),imag(h2),'b')
                hold on
                plot(real(B(1,1)),imag(B(1,1)),'.red', 'MarkerSize',5)
                hold on
                plot(real(-B(1,1)),imag(-B(1,1)),'.red', 'MarkerSize',5)
                axis equal              
                title('The matrix A is J-scalar')
                return
            else %if C~=diag(1,0,...,0)
                C1=[]; C2=[];
                   for t=1:size(C,2)
                       [U,C]=eig(C);
                       u=U(:,t);
                           if abs(real(u'*J*u))>=Tol %no null J-norm
                               if real(u'*J*u)>0 %positive J-norm
                                   C1=[C1 C(t,t)];
                               else
                                   C2=[C2 C(t,t)]; %negative J-norm
                               end
                           end
                   end
                [interla]=interlating(C1,C2);
                if isequal(B(1,1),conj(B(1,1)))%if B  real
                    if interla==2 || isempty(C1)==1 || isempty(C2)==1
                        p1=0;
                            for k=1:size(C1,2)
                                p1=p1+C1(k); 
                            end
                        p2=0;
                            for k=1:size(C2,2)
                                p2=p2+C2(k); 
                            end
                            if B(1,1)*(p1-p2)>0
                                t=1:0.005:10;
                                h=B(1,1)*(p1-p2)*t;
                                plot(real(h),imag(h),'b')
                                hold on 
                                plot(real(B(1,1)*(p1-p2)),imag(B(1,1)*(p1-p2)),'.red','MarkerSize',5)
                                axis equal       
                                axis([-3+real(-B(1,1)*(p1-p2)),real(B(1,1)*(p1-p2))*10,-3,3])
                                title('The matrix A is J-scalar')
                                return
                            elseif B(1,1)*(p1-p2)<0
                                t=1:0.005:10;
                                h=B(1,1)*(p1-p2)*t;
                                plot(real(h),imag(h),'b')
                                hold on
                                plot(real(B(1,1)*(p1-p2)),imag(B(1,1)*(p1-p2)),'.red','MarkerSize',5)
                                axis equal              
                                title('The matrix A is J-scalar')
                                axis([10*real(B(1,1)*(p1-p2)),real(B(1,1)*(p1-p2))+2,-3,3])                                
                                return 
                            else
                                text(0.38,0.55,'W_C^J(A) is ... ? ','Color','red');
                                title('The matrix A is J-scalar')
                                return  
                            end
                    end
                else
                    text(0.38,0.55,'W_C^J(A) is ... ? ','Color','red');
                    title('The matrix A is J-scalar')
                    return
                end
            end
        end
end

%%
%Degenerate case (A is Hermitian)
if isequal(J,eye(size(J,2))) || isequal(J,-eye(size(J,2))) %definite case
    
   if A==A'
       E=[];
       for r=1:size(A,2)
           E(1,r)=r;
       end
       p=perms(E);
       D=eig(A);
       
       q=[];
       for r=1:size(p,1)
           d=0;
           for t=1:size(A,2)
           d=d+D(t)*C(p(r,t),p(r,t));
           end
           q=[q d];
       end
       
     
        alpha=min(q);beta=max(q);
        t=0:0.0005:1;
        seg=alpha*(1-t)+beta*t;  
        plot(real(seg),0,'b','linewidth',1.4)
        hold on
        plot(real(alpha),imag(alpha),'.red', 'MarkerSize',5)
        hold on
        plot(real(beta),imag(beta),'.red', 'MarkerSize',5)
        axis equal
        axis([alpha-2, beta+2,-2,2])
        title('The matrix A is Hermitic')
        return
   end

end 

%%
%If A is J-Hermitian
B=J*A;
if B'==B
    if ~isequal(J,eye(size(J,2))) && ~isequal(J,-eye(size(J,2))) %indefinido
        c=0;
            if C(1,1)==1
                for j=2:size(C,2)
                    if C(j,j)~=0
                        c=1;
                        break
                    end
                end
            else
                 c=1;
            end
            
            if c==0 %C=diag(1,0,...,0)
                text(0.18,0.55,'W_J(A) is the real line, the real line with out a point','Color','red');
                text(0.38,0.5,'or two real half rays','Color','red');
                title('The matrix A is J-Hermitian')
                return
            else
                text(0.33,0.55,'W_C^J(A) is a line or a semiline','Color','red');
                title('The matrix A is J-Hermitian')
                return
            end
    end
end
 

%%
%Sort the diagonal entries of C by descending order
c=sort((diag(C)),'descend'); 
for k=1:size(C,1)
   for s=1:size(C,2)
      if k~=s
          C(k,s)=0;
      else
          C(k,s)=c(k);
      end
   end
end



%Sort the diagonal entries of J by descending order
j=sort((diag(J)),'descend'); 
for k=1:size(J,1)
   for s=1:size(J,2)
      if k~=s
          J(k,s)=0;
      else
          J(k,s)=j(k);
      end
   end
end



%Checking if the diagonal entries of the matrix C do not intrelace (in the
%indefinite case) 
%deginter=0;
if isequal(J,eye(size(J,2))) || isequal(J,-eye(size(J,2))) %definite case
    definite=1;MC=2; 
    C1=[]; C2=[];
        for t=1:size(C,2)
            [U,D]=eig(C);
            u=U(:,t);
                if abs(real(u'*J*u))>=Tol %no null J-norm
                    if real(u'*J*u)>0 %positive J-norm
                        C1=[C1 D(t,t)];
                    else
                        C2=[C2 D(t,t)]; %negative J-norm
                    end
                end
        end
else
    definite=0; %indefinite case
    C1=[]; C2=[];
        for t=1:size(C,2)
            [U,D]=eig(C);
            u=U(:,t);
                if abs(real(u'*J*u))>=Tol %no null J-norm
                    if real(u'*J*u)>0 %positive J-norm
                        C1=[C1 D(t,t)];
                    else
                        C2=[C2 D(t,t)]; %negative J-norm
                    end
                end
        end
    [interla]=interlating(C1,C2);
        if interla==2 %the diagonal entries of the matrix C do not intrelace
            c1=sort((real(C1)),'descend'); %Sort the elements of C1 by descending order
            c2=sort((real(C2)),'descend'); %Sort the elements of C2 by descending order
                if real(C1(size(c1,2)))>real(c2(1,1))
                    MC=0; %The diagonal entries of C with positive J-norm are biger than the diagonal entries with negative J-norm
                elseif real(c2(size(c2,2)))>real(c1(1,1))
                    MC=1; %The diagonal entries of C with negative J-norm are biger than the diagonal entries with positive J-norm
                else %real(c2(size(c2,2)))==real(c1(1,1))
                    eq=0;
                    for r=1:size(c1,2)
                        for s=1:size(c2,2)
                            if abs(c1(r)-c2(s))>Tol %c1(r)~=c2(s)
                                if c1(r)>c2(s)
                                    MC=0;
                                    eq=1;
                                    break
                                else
                                    MC=1;
                                    eq=1;
                                    break
                               end
                            end
                        end
                    end
                    if eq==0 %os elementos de C1 so todos iguais aos elementos de C2
                        MC=3;
                    end
                    
                end
        else
            error('There must not exist interlating eigenvalues of C');
        end
end


        
%%    
[degenerate1,degenerate2]=compute(A,J,C,C1,C2,m,Tol,MC);
           
    if definite==1
        %title('C-Numerical Range');
        xlabel('Real Axis');
        ylabel('Imaginary Axis');
    else
        if degenerate1==0
            if degenerate2==1
                step_8(A,J,C,Tol);
            else
                title('Tracial Numerical Range');
                xlabel('Real Axis');
                ylabel('Imaginary Axis');
            end 
        end
    end        
        
       







  
