function [aux,eig_real]=degenerate(A,J,m,Tol,direc)

% Cheking if there exists at least one directions for which the eigenvalues
% of T=(exp(pi*i*(w-1)/(2*m))*A+ exp(-pi*i*(w-1)/(2*m))*J*A'*J)/2
% are all real with anisotropic eigenvectors
%%
vec=[];eig_real=[];dreal=[];
for t=1:size(direc,2)
    w=direc(t);
    T=(exp(pi*i*(w-1)/(2*m))*A+ exp(-pi*i*(w-1)/(2*m))*J*A'*J)/2;
    [U,D]=eig(T);
    count1=0;
        for s=1:size(U,2)
            u=U(:,s);
                if abs(real(u'*J*u))>=Tol && abs(imag(D(s,s)))<=Tol
                    count1=count1+1; %Number of real eigenvalues with anisotropic eigenvectors in the direction w=direc(t)
                end
        end
    vec=[vec count1];
    dreal=[dreal w]; %Directions for which there exists at least one real eigenvalue
end

count2=0;
for t=1:size(vec,2)
    if vec(t)==size(A,2)
        eig_real=[eig_real dreal(t)]; %In this direction the eigenvalues are all real with anisotropic eigenvectors
        count2=count2+1;  %Counts the number of directions for which the eigenvalues are real with anisotropic eigenvectors
     end
end

aux=0; 
if count2>=1 %There exists at least one direction for which the eigenvalues are all real and anisotropic eigenvectors
    aux=1;
end

